﻿using System.Collections.Generic;
using System.Web.Mvc;
using System.Web.Routing;
using Orchard.Mvc.Routes;
using Contrib.Taxonomies.Routing;

namespace Contrib.Taxonomies {
    public class Routes : IRouteProvider {
        private readonly ITaxonomySlugConstraint _taxonomySlugConstraint;

        public Routes(ITaxonomySlugConstraint taxonomySlugConstraint) {
            _taxonomySlugConstraint = taxonomySlugConstraint;
        }

        public void GetRoutes(ICollection<RouteDescriptor> routes) {
            foreach (var routeDescriptor in GetRoutes())
                routes.Add(routeDescriptor);
        }

        public IEnumerable<RouteDescriptor> GetRoutes() {
            return new[] {
                             new RouteDescriptor {
                                                    Priority = 11,
                                                    Route = new Route(
                                                         "{taxonomySlug}/{*path}",
                                                         new RouteValueDictionary {
                                                                                      {"area", "Contrib.Taxonomies"},
                                                                                      {"controller", "Home"},
                                                                                      {"action", "List"}
                                                                                  },
                                                         new RouteValueDictionary {
                                                                                      {"taxonomySlug", _taxonomySlugConstraint}
                                                                                  },
                                                         new RouteValueDictionary {
                                                                                      {"area", "Contrib.Taxonomies"}
                                                                                  },
                                                         new MvcRouteHandler())
                                                 }
                         };
        }
    }
}