using JetBrains.Annotations;
using Orchard.Gallery.Interfaces;
using Orchard.Localization;
using Orchard.Security;
using Orchard.UI.Navigation;

namespace Orchard.Gallery {
    [UsedImplicitly]
    public class AdminMenu : INavigationProvider {
        private readonly IPackageService _packageService;

        public AdminMenu(IPackageService packageService) {
            _packageService = packageService;
        }

        public string MenuName {
            get { return "admin"; }
        }

        public Localizer T { get; set; }

        public void GetNavigation(NavigationBuilder builder) {
            builder.Add(T("Gallery"), "1", menu => menu
                .Action("Index","Admin", new { area = "Orchard.Gallery" })
                .Permission(StandardPermissions.SiteOwner));
        }
    }
}