using JetBrains.Annotations;
using Orchard.Services;
using Orchard.TaskLease.Services;
using Orchard.Tasks;

namespace Orchard.Gallery.PackageSynchronization {
    [UsedImplicitly]
    public class PackageSyncTask : IBackgroundTask {

        private readonly IPackageSynchronizer _packageSynchronizer;
        private readonly ITaskLeaseService _taskLeaseService;
        private readonly IClock _clock;

        public PackageSyncTask(
            IPackageSynchronizer packageSynchronizer,
            ITaskLeaseService taskLeaseService,
            IClock clock
            ) {
            _packageSynchronizer = packageSynchronizer;
            _taskLeaseService = taskLeaseService;
            _clock = clock;
        }

        public void Sweep() {
            if (_taskLeaseService.Acquire("IPackageSynchronizer", _clock.UtcNow.AddHours(1)) != null) {
                _packageSynchronizer.Synchronize();
            }
        }
    }
}