using JetBrains.Annotations;
using Orchard.Services;
using Orchard.TaskLease.Services;
using Orchard.Tasks;

namespace Orchard.Gallery.RatingSynchronization {
    [UsedImplicitly]
    public class RatingSyncTask : IBackgroundTask {

        private readonly IRatingSynchronizer _ratingSynchronizer;
        private readonly ITaskLeaseService _taskLeaseService;
        private readonly IClock _clock;

        public RatingSyncTask(
            IRatingSynchronizer ratingSynchronizer, 
            ITaskLeaseService taskLeaseService,
            IClock clock) {
            _ratingSynchronizer = ratingSynchronizer;
            _taskLeaseService = taskLeaseService;
            _clock = clock;
        }

        public void Sweep() {
            if (_taskLeaseService.Acquire("IRatingSynchronizer", _clock.UtcNow.AddHours(1)) != null) {
                _ratingSynchronizer.Synchronize();
            }
        }
    }
}