﻿using System;
using System.Collections.Generic;
using System.Linq;
using Orchard.ContentManagement;
using Orchard.ContentManagement.Utilities;
using Orchard.Gallery.Models;

namespace Orchard.Gallery.UserPackages {
    public class UserPackagesPart : ContentPart {
        public UserPackagesPart() {
            UserkeyRecord = new LazyField<Userkey>();
            UserkeyPackageRecords = new LazyField<IEnumerable<UserkeyPackage>>();
        }

        public LazyField<Userkey> UserkeyRecord { get; set; }
        public LazyField<IEnumerable<UserkeyPackage>> UserkeyPackageRecords { get; set; }

        public Guid? AccessKey {
            get { return UserkeyRecord.Value == null ? (Guid?) null : UserkeyRecord.Value.AccessKey; }
        }

        public IEnumerable<PackageEntry> Packages {
            get { return UserkeyPackageRecords.Value.Select(x => new PackageEntry {PackageId = x.PackageId, RegisteredUtc = x.RegisteredUtc}); }
        }

        public class PackageEntry {
            public string PackageId { get; set; }
            public DateTime? RegisteredUtc { get; set; }
        }
    }
}